<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class douAttribute {
    /**
     * +----------------------------------------------------------
     * 获取列表
     * +----------------------------------------------------------
     */
    function get_attribute_list($module, $cat_id = '', $item_id = '', $mode = 'common', $attribute_data = array()) {
        if ($cat_id)
            $and = ' AND cat_id = 0 OR cat_id IN (' . $cat_id . $GLOBALS['dou']->dou_parent_id($module . '_category', $cat_id) . ')';
        
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('attribute') . " WHERE module = '$module'" . $and . " ORDER BY sort ASC, att_id ASC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $value_list = $item_id ? $this->get_value_list($module, $item_id, $row['att_id'], $mode, $attribute_data) : array();
            $selected_value_id = $attribute_data[$row['att_id']] ? $attribute_data[$row['att_id']] : (is_array($value_list) ? $value_list[0]['id'] : '');
            
            if (defined('IS_ADMIN') || (!defined('IS_ADMIN') && $value_list) ) {
                $attribute_list[] = array (
                        "att_id" => $row['att_id'],
                        "name" => $row['name'],
                        "type" => $row['type'],
                        "value_list" => $value_list,
                        "selected_value_id" => $selected_value_id,
                        "selected_value_price_change" => $GLOBALS['dou']->get_value('attribute_value', 'price_change', "id = '$selected_value_id'")
                );
            }
        }
        
        return $attribute_list;
    }

    /**
     * +----------------------------------------------------------
     * 获取款式列表
     * +----------------------------------------------------------
     */
    function get_value_list($module, $item_id, $att_id, $mode = 'common', $attribute_data = array()) {
        global $dou;

        $sql = "SELECT * FROM " . $dou->table('attribute_value') . " WHERE module = '$module' AND item_id = '$item_id' AND att_id = '$att_id' ORDER BY id ASC";
        $query = $dou->query($sql);
        $i = 1;
        while ($row = $dou->fetch_array($query)) {
            // 如果属性第一个值设置了价格浮动，将自动清零
            if ($i == 1 && $row['price_change'] > 0)
                $dou->query("UPDATE " . $dou->table('attribute_value') . " SET price_change = '0' WHERE id = '$row[id]'");
            
            $price_change_format = $row['price_change'] == 0 ? '' : ' ' . ($row['price_change'] > 0 ? '+' . $row['price_change'] : $row['price_change']); 
            
            if ($mode == 'html') {
                if ($row['type'] == 'image') {
                    if ($row['image']) {
                        $image = '<span class="img" onclick="' . "attImage('$att_id', '$row[id]');" . '"><img src="' . $dou->dou_file($row['image']) . '"/></span>';
                    } else {
                        $image = '<span class="upload" onclick="' . "attImage('$att_id', '$row[id]');" . '"><i class="fa fa-image"></i></span>';
                    }
                }
                
                $value_list .= '<li title="' . $row['remark'] . '">' . $image . '<span class="value">' . $row['value'] . $price_change_format . '</span><span onclick="' . "attAction('del', '$module', '$item_id', '$att_id', '$row[value]');" . '" class="del">X</span></li>';
            } else {
                if ($attribute_data[$att_id]) {
                    $cur = $row['id'] == $attribute_data[$att_id] ? true : false;
                } else {
                    $cur = $i == 1 ? true : false;
                }
                
                $value_list[] = array (
                        "id" => $row['id'],
                        "value" => $row['value'],
                        "json" => json_encode(array("id" => $row['id'], "value" => $row['value'], "price_change" => $row['price_change'])),
                        "image" => $dou->dou_file($row['image']),
                        "remark" => $row['remark'],
                        "price_change" => $row['price_change'],
                        "price_change_format" => $price_change_format,
                        "cur" => $cur
                );
            }
         
            $i++;
        }

        return $value_list;
    }

}

?>